#include <avr/io.h>
#include <util/delay.h>

void UP_MOTOR_set_duty_cycle(float percentage)
{
	if (percentage >= 0.0f && percentage <= 1.0f) {
		OCR0A = percentage * 256 - 1;

	} else {
		/* duty cycle 0% */
		OCR0A = -1;
	}
}

void DOWN_MOTOR_set_duty_cycle(float percentage)
{
	if (percentage >= 0.0f && percentage <= 1.0f) {
		OCR0B = percentage * 256 - 1;

	} else {
		/* duty cycle 0% */
		OCR0B = -1;
	}
}

void MOTORS_init()
{
	TCCR0A = 0;
	/* Fast PWM mode 
	 * Top at 0xFF
	 */
    TCCR0A |= (3 << WGM00);
    /* Clear on comp OCR0A */
    TCCR0A |= (1 << COM0A1);
    /* Clear on comp OCR0B */
    TCCR0A |= (1 << COM0B1);
    /* prescaler 1*/
    TCCR0B |= (1 << CS00);

    UP_MOTOR_set_duty_cycle(1.0f);
    DOWN_MOTOR_set_duty_cycle(1.0f);
}

int main(void) {
	/* output for UP_MOTOR */
	DDRB |= (1 << PB3);
	PORTB &= ~(1 << PB3);
	/* output for DOWN_MOTOR */
	DDRB |= (1 << PB4);
	PORTB &= ~(1 << PB4);

	DDRB |= (1 << PB0);
	PORTB &= ~(1 << PB0);
	DDRB |= (1 << PB1);
	PORTB |= (1 << PB1);

	DDRB |= (1 << PB6);
	PORTB &= ~(1 << PB6);
	DDRB |= (1 << PB7);
	PORTB |= (1 << PB7);

	MOTORS_init();

	return 0;
}
